<!-- Copyright (c) 2020, Institute of Automatic Control - RWTH Aachen University
   All rights reserved. -->

<!--
Launches the ar_render_node.
The node receives the images from an image topic and uses the camera frame id.
The objects and camera poses are received via tf.
-->
<launch>
  <arg name="mesh_path" default="$(find scigl_render)/3d_models/monkey.dae"/>
  <arg name="object_frame_id" default="object"/>
  <arg name="world_frame_id" default="world"/>
  <arg name="light_frame_id" default="light"/>
  <arg name="enable_usb_cam" default="false"/>

  <!--Augmented reality rendering based on usb_cam -->
  <node name="ar_render_node" pkg="scigl_render_ros" type="ar_render_node">
    <param name="mesh_path" value="$(arg mesh_path)"/>
    <param name="object_frame_id" value="$(arg object_frame_id)"/>
    <param name="world_frame_id" value="$(arg world_frame_id)"/>
    <param name="light_frame_id" value="$(arg light_frame_id)"/>    
  </node>

  <!-- use calibrated usb_cam as background
  !!! Beware: you might see your own face !!! -->
  <node name="usb_cam" pkg="usb_cam" type="usb_cam_node" output="screen" if="$(arg enable_usb_cam)">
    <param name="video_device" value="/dev/video0" />
    <param name="image_width" value="640" />
    <param name="image_height" value="480" />
    <param name="pixel_format" value="yuyv" />
    <param name="camera_frame_id" value="usb_cam" />
    <param name="io_method" value="mmap"/>
    <remap from="/usb_cam/image_raw" to="/camera/color/image_raw"/>
  </node>
  <node pkg="tf2_ros" type="static_transform_publisher" name="usb_cam_tf" args="0 0 0 0 0 0 $(arg world_frame_id) usb_cam" if="$(arg enable_usb_cam)"/>


</launch>